
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

Opt('MustDeclareVars', 1)
Opt("GUIOnEventMode", 0)
;Constatnt
Const $conProgName = "Phone Book"
Const $conMyName = "AYman Henry"
Const $conMyEmail = "AymHenry@Hotmail.com"

Const $conDbFile = "PhoneBook.mdb" ; it has to be on script current Dir
Const $conTable = "tblPhoneBook"
Const $conOK = 1, $conEdit =1, $conAdd =0

;Global var
Global $oMyError = ObjEvent("AutoIt.Error","MyErrFunc")

	Global $objDBSystem, $dbDatatBase, $recRecordSet

	Global $cmdAdd, $cmdEdit, $cmdDelete, $cmdCancel
	Global $cmdNext, $cmdFirst, $cmdPrev, $cmdLast
	Global $cmdSave
	Global $lngAddEdit
	
; Sreen Fields
	Global $txtFirstName, $txtMidName, $txtLastName
	Global $txtMobile, $txtHomePhone, $txtAddress
	Global $txtRecPos

if Setup() = $conOK Then
	Main ()
EndIf
	
Exit
;==================

Func Setup ()
		
	$objDBSystem = ObjCreate("DAO.DBEngine.36") 
	if $conOK <> FileExists (@ScriptDir & "\" & $conDbFile) Then
		Msgbox (16,$conProgName,"Database File is not found " & @Lf & @ScriptDir & "\" & $conDbFile)
		;Return 0
		Exit
	endif
	
	$dbDatatBase = $objDBSystem.OpenDatabase (@ScriptDir & "\" & $conDbFile)
	$recRecordSet = $dbDatatBase.OpenRecordset ("Select * From " & $conTable)
		
	Return $conOK
EndFunc

Func Shtdown() ; Close data base
	$recRecordSet.Close
	$dbDatatBase.Close
EndFunc

Func KeysSetup ( $lngMode )
	Local $nState1, $nState2
	
	if ($recRecordSet.Eof = -1 And $recRecordSet.Bof =-1) or $lngMode = 1 Then ; Blank Table
		$nState1 = $GUI_ENABLE
		$nState2 = $GUI_DISABLE
		;cmdAdd_Click ()
	Else
		$nState1 = $GUI_DISABLE
		$nState2 = $GUI_ENABLE
		;$recRecordSet.MoveFirst
	EndIf

		GUICtrlSetState($cmdSave, $nState1)
		GUICtrlSetState($cmdAdd, $nState2)
		GUICtrlSetState($cmdEdit, $nState2)
		GUICtrlSetState($cmdCancel, $nState1)
		GUICtrlSetState($cmdDelete, $nState2)
		
		GUICtrlSetState($cmdNext, $nState2)
		GUICtrlSetState($cmdPrev, $nState2)
		GUICtrlSetState($cmdFirst, $nState2)
		GUICtrlSetState($cmdLast, $nState2)
EndFunc

Func Main()
	Local $frmMain
	Local $Label1, $Label2, $Label3, $Label4, $Label5, $Label6, $Label7

	Local $Graphic1, $nMsg
	
	#Region ### START Koda GUI section ### Form=K:\Ayman\Script\PhoneBook\frmMain.kxf
	$frmMain = GUICreate("Phone Book", 489, 355, 549, 207)
	$Label1 = GUICtrlCreateLabel("First Name", 40, 72, 69, 20)
	$Label2 = GUICtrlCreateLabel("Mobile", 40, 182, 45, 20)
	$Label3 = GUICtrlCreateLabel("Home Phone", 40, 219, 83, 20)
	$Label5 = GUICtrlCreateLabel("Middel Name", 40, 109, 85, 20)
	$Label6 = GUICtrlCreateLabel("Last Name", 40, 146, 69, 20)
	$txtFirstName = GUICtrlCreateInput("", 128, 72, 161, 24)
	GUICtrlSetLimit(-1, 30)
	$txtMidName = GUICtrlCreateInput("", 128, 108, 161, 24)
	GUICtrlSetLimit(-1, 30)
	$txtLastName = GUICtrlCreateInput("", 128, 144, 161, 24)
	GUICtrlSetLimit(-1, 30)
	$txtMobile = GUICtrlCreateInput("", 128, 180, 161, 24)
	GUICtrlSetLimit(-1, 30)
	$txtHomePhone = GUICtrlCreateInput("", 128, 216, 161, 24)
	GUICtrlSetLimit(-1, 30)
	$Label4 = GUICtrlCreateLabel("Address", 47, 256, 55, 20)
	$txtAddress = GUICtrlCreateInput("", 129, 252, 289, 24)
	GUICtrlSetLimit(-1, 200)
	
	$Label7 = GUICtrlCreateLabel("Phone Book", 40, 24, 142, 32, $SS_CENTER)
	GUICtrlSetFont(-1, 14, 800, 0, "Tahoma")

	$cmdAdd = GUICtrlCreateButton("&Add", 352, 50, 92, 31, 0)
	$cmdEdit = GUICtrlCreateButton("&Edit", 352, 90, 92, 31, 0)
	$cmdDelete = GUICtrlCreateButton("&Delete", 352, 130, 92, 31, 0)
	$cmdSave = GUICtrlCreateButton("&Save", 352, 170, 92, 31, 0)
		GUICtrlSetState(-1, $GUI_DISABLE)

	$cmdCancel = GUICtrlCreateButton("&Cancel", 352, 210, 92, 31, 0)
	
	$cmdFirst = GUICtrlCreateButton("|<", 132, 296, 33, 33, 0)
	$cmdPrev = GUICtrlCreateButton("<", 176, 296, 33, 33, 0)
	
	$txtRecPos = GUICtrlCreateInput("", 220, 300, 70, 24, $ES_CENTER) 
	
	$cmdNext = GUICtrlCreateButton(">", 296, 296, 33, 33, 0)
	$cmdLast = GUICtrlCreateButton(">|", 337, 296, 33, 33, 0)
	
;	$Graphic1 = GUICtrlCreateGraphic(24, 56, 433, 233)
	
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###
	
	if $recRecordSet.Eof = -1 ANd $recRecordSet.bof = -1 Then
		cmdAdd_Click ()
	Else
		KeysSetup (0)
		cmdLast_Click()
	EndIf	

	While 1
	$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				Shtdown ()
				Return
			Case $cmdNext
				cmdNext_Click()
			Case $cmdPrev
				cmdPrev_Click()
			Case $cmdFirst
				cmdFirst_Click()
			Case $cmdLast
				cmdLast_Click()		
				
			Case $cmdAdd
				cmdAdd_Click()
			Case $cmdEdit
				cmdEdit_CLick()
			Case $cmdDelete 
				cmdDelete_Click()
			Case $cmdSave
				cmdSave_Click()
			Case $cmdCancel
				cmdCancel_Click()
				
		EndSwitch
	WEnd
EndFunc

Func cmdAdd_Click ()
	$lngAddEdit = $conAdd
	$recRecordSet.AddNew
	
	ShowData()

	GUICtrlSetData ($txtRecPos, $recRecordSet.RecordCount + 1 & " of " & $recRecordSet.RecordCount + 1)
	
	KeysSetup (1)	
EndFunc

Func cmdEdit_Click ()
	$lngAddEdit = $conEdit
	$recRecordSet.Edit
	KeysSetup (1)
EndFunc

Func cmdCancel_Click ()
	if ($recRecordSet.Eof = -1 And $recRecordSet.Bof =-1)  Then ; Blank Table
		Return
	EndIf
	
	$recRecordSet.CancelUpdate
	ShowData()
	KeysSetup (0)
EndFunc

Func cmdSave_Click ()
		
	SaveRec ()
	
	if $lngAddEdit= $conAdd Then
		cmdLast_Click ()		
	Else
		ShowData()
	EndIf
	KeysSetup (0)
EndFunc

Func cmdDelete_Click ()
	If 7 = MsgBox (32 + 4,$conProgName, "Are you sure delete the current record Permanently?" ) Then ; if no
		Return
	endif
	
	$recRecordSet.Delete
	$recRecordSet.MoveLast
	
	if ($recRecordSet.Eof = -1 And $recRecordSet.Bof =-1)  Then ; Blank Table
		cmdAdd_Click()
	Else	
		cmdLast_Click()
	EndIf
EndFunc

Func cmdNext_Click ()

	$recRecordSet.MoveNext
	If $recRecordSet.Eof = -1 Then
			$recRecordSet.MoveLast
	EndIf
	ShowData()
EndFunc

Func cmdPrev_Click ()
	$recRecordSet.MovePrevious
	If $recRecordSet.Bof = -1 Then
			$recRecordSet.MoveFirst
	EndIf
	ShowData()
EndFunc

Func cmdFirst_Click ()
	$recRecordSet.MoveFirst
	ShowData()
EndFunc

Func cmdLast_Click ()
	$recRecordSet.MoveLast
	ShowData()
EndFunc

Func ShowData()
	
	if ($recRecordSet.Eof = -1 And $recRecordSet.Bof =-1)  Then ; Blank Table

			GUICtrlSetData ($txtRecPos,  "0 of 0"  )
			GUICtrlSetData ($txtFirstName, "" )
			GUICtrlSetData ($txtMidName, "" )
			GUICtrlSetData ($txtLastName, "" )
			GUICtrlSetData ($txtMobile, "" )
			GUICtrlSetData ($txtHomePhone, "" )
			GUICtrlSetData ($txtAddress, "" )
		Return
	EndIf

	With $recRecordSet	
			If .Eof = -1  Then .MoveLast
			If .Bof = -1  Then .MoveFirst
			
			GUICtrlSetData ($txtRecPos, .AbsolutePosition + 1 & " of " & .RecordCount )
			GUICtrlSetData ($txtFirstName, .Fields(1).Value )
			GUICtrlSetData ($txtMidName, .Fields(2).Value )
			GUICtrlSetData ($txtLastName, .Fields(3).Value )
			GUICtrlSetData ($txtMobile, .Fields(4).Value )
			GUICtrlSetData ($txtHomePhone, .Fields(5).Value )
			GUICtrlSetData ($txtAddress, .Fields(6).Value )
	EndWith

;msgbox (0,"Test","Rec Status:" & $recRecordSet.RecordStatus )

EndFunc

Func SaveRec()
	
	With $recRecordSet
		;.Edit
			;.Fields(0).Value = 
			.Fields(1).Value = GUICtrlRead ($txtFirstName)
			.Fields(2).Value = GUICtrlRead ($txtMidName)
			.Fields(3).Value = GUICtrlRead ($txtLastName)
			.Fields(4).Value = GUICtrlRead ($txtMobile)
			.Fields(5).Value = GUICtrlRead ($txtHomePhone)
			.Fields(6).Value = GUICtrlRead ($txtAddress)
		.Update
		
	EndWith

EndFunc	

Func MyErrFunc()

  Local $HexNumber=hex($oMyError.number,8)

  Msgbox(16,$conProgName,"Error intercepted a COM Error !"       & @CRLF  & @CRLF & _
             "err.description is: "    & @TAB & $oMyError.description    & @CRLF & _
             "err.windescription:"     & @TAB & $oMyError.windescription & @CRLF & _
             "err.number is: "         & @TAB & $HexNumber              & @CRLF & _
             "err.lastdllerror is: "   & @TAB & $oMyError.lastdllerror   & @CRLF & _
             "err.scriptline is: "     & @TAB & $oMyError.scriptline     & @CRLF & _
             "err.source is: "         & @TAB & $oMyError.source         & @CRLF & _
             "err.helpfile is: "       & @TAB & $oMyError.helpfile       & @CRLF & _
             "err.helpcontext is: "    & @TAB & $oMyError.helpcontext _
            )

  SetError(1); to check for after this function returns
Endfunc